# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Package-Stash-XS
Version:	0.29
Release:	6.%{__distinit}%{__distvers}
Summary:	Faster and more correct implementation of the Package::Stash API
License:	GPL+ or Artistic
URL:		https://metacpan.org/release/Package-Stash-XS
Source0:	https://cpan.metacpan.org/modules/by-module/Package/Package-Stash-XS-%{version}.tar.gz
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	gcc
BuildRequires:	make
BuildRequires:	perl-devel
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module Runtime
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
BuildRequires:	perl(XSLoader)
# Test Suite
BuildRequires:	perl(B)
BuildRequires:	perl(base)
BuildRequires:	perl(blib)
BuildRequires:	perl(constant)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(IO::Handle)
BuildRequires:	perl(IPC::Open3)
BuildRequires:	perl(lib)
%if 0%{?fedora} > 15 || 0%{?rhel} > 6
BuildRequires:	perl(Package::Anon)
%endif
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(Symbol)
BuildRequires:	perl(Test::Fatal)
BuildRequires:	perl(Test::More) >= 0.88
BuildRequires:	perl(Test::Requires)
BuildRequires:	perl(Variable::Magic)
# Optional Test Requirements
BuildRequires:	perl(CPAN::Meta) >= 2.120900
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

# Don't "provide" private Perl libs
%{?perl_default_filter}

%description
This is a back-end for Package::Stash, which provides the functionality in a
way that's less buggy and much faster. It will be used by default if it's
installed, and should be preferred in all environments with a compiler.

%prep
%setup -q -n Package-Stash-XS-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%if 0%{?_licensedir:1}
%license LICENSE
%else
%doc LICENSE
%endif
%doc Changes CONTRIBUTING README
%{perl_vendorarch}/auto/Package/
%{perl_vendorarch}/Package/
%{_mandir}/man3/Package::Stash::XS.3*

%changelog
* Tue Mar 10 2020 Paul Howarth <paul@city-fan.org> - 0.29-6
- BR: perl(blib) for t/00-compile.t

* Wed Jun  5 2019 Paul Howarth <paul@city-fan.org> - 0.29-3
- Perl 5.30 rebuild

* Wed Jan  2 2019 Paul Howarth <paul@city-fan.org> - 0.29-1
- Update to 0.29
  - Quiet compiler warning (GH#2)
  - Canonical repository moved to https://github.com/moose/Package-Stash-XS
- Package new CONTRIBUTING file
- Don't bother running the extra tests

* Thu Jun 28 2018 Paul Howarth <paul@city-fan.org> - 0.28-18
- Perl 5.28 rebuild

* Mon Aug  7 2017 Paul Howarth <paul@city-fan.org> - 0.28-16
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl

* Tue Jun 13 2017 Paul Howarth <paul@city-fan.org> - 0.28-14
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - BR: perl-devel unconditionally
  - Drop workaround for building with Test::More < 0.88

* Thu Jul 21 2016 Paul Howarth <paul@city-fan.org> - 0.28-12
- Fix FTBFS when perl is not in the SRPM build root

* Tue May 17 2016 Paul Howarth <paul@city-fan.org> - 0.28-11
- BR: perl-devel and perl-generators where possible
- Simplify find commands using -empty and -delete

* Fri Sep 12 2014 Paul Howarth <paul@city-fan.org> - 0.28-6
- Drop support for building with ExtUtils::MakeMaker < 6.30
- Drop support for building without Test::LeakTrace
- Drop support for building without Test::Requires
- Drop %%defattr, redundant since rpm 4.4
- Use %%license where possible
- Classify buildreqs by usage

* Tue Jul 23 2013 Paul Howarth <paul@city-fan.org> - 0.28-2
- Perl 5.18 rebuild

* Tue Jul 16 2013 Paul Howarth <paul@city-fan.org> - 0.28-1
- Update to 0.28
  - Fix test issue

* Tue Jul 16 2013 Paul Howarth <paul@city-fan.org> - 0.27-1
- Update to 0.27
  - Handle magic more correctly in add_symbol and get_or_add_symbol
- Add upstream patch to avoid build dependency on Package::Stash
- BR: perl(Variable::Magic) for the test suite
- Update patches as needed

* Fri Jan  4 2013 Paul Howarth <paul@city-fan.org> - 0.26-1
- Update to 0.26
  - Internal refactorings to support Package::Anon stashes
- BR: perl(base), perl(constant) and perl(Test::Requires) for test suite
- BR: perl(Package::Anon) for test suite if we have perl ≥ 5.14
- Update patches for old distro compatibility
- Explicitly run the release/author tests
- Add patch to support building without Test::Requires on ancient distros

* Tue Jul 10 2012 Paul Howarth <paul@city-fan.org> - 0.25-3
- BR: perl(File::Temp), perl(lib), perl(Scalar::Util) and perl(XSLoader)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorarch}
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Use %%{_fixperms} macro rather than our own chmod incantation

* Tue Sep  6 2011 Paul Howarth <paul@city-fan.org> - 0.25-1
- Update to 0.25
  - Fix compilation on perl 5.8 (CPAN RT#70762)
- Drop upstreamed patch for CPAN RT#70762

* Tue Sep  6 2011 Paul Howarth <paul@city-fan.org> - 0.24-1
- Update to 0.24
  - Invalid package names (for instance, Foo:Bar) are not allowed
  - Invalid stash entry names (anything containing ::) are not allowed
- Add patch to support perl 5.8 due to pregcomp API change (CPAN RT#70762)
- Update patches to apply cleanly

* Tue Aug  9 2011 Paul Howarth <paul@city-fan.org> - 0.23-1
- Update to 0.23
  - Fix the test for scalar values, again
  - Disallow assigning globrefs to scalar glob slots (this doesn't actually
    make any sense)
- Update patches for old ExtUtils::MakeMaker and Test::More versions

* Tue Jun 21 2011 Paul Howarth <paul@city-fan.org> - 0.22-2
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Sat Mar  5 2011 Paul Howarth <paul@city-fan.org> - 0.22-1
- Update to 0.22
  - Make the namespace cache lazy and weak, in case the stash is deleted
  - However, this doesn't work on 5.8, so disable the namespace caching
    entirely there
- Update patches to apply cleanly

* Tue Jan 25 2011 Paul Howarth <paul@city-fan.org> - 0.21-1
- Update to 0.21
  - Make the leak tests author-only, since some smokers run release tests
  - Fix some XS forward compat stuff
- Update patches to apply cleanly

* Wed Jan 12 2011 Paul Howarth <paul@city-fan.org> - 0.20-1
- Update to 0.20
  - Lower perl prereq to 5.8.1
  - Make the leak tests release-only
- Update patches to apply cleanly
- Drop no-Test::Requires patch, no longer needed
- Drop buildreq perl(Test::Requires), no longer needed
- Add patch to skip memory leak tests if we don't have Test::LeakTrace

* Thu Jan  6 2011 Paul Howarth <paul@city-fan.org> - 0.19-1
- Update to 0.19 (more correct validity test for scalars)
- Update patch for old Test::More versions

* Wed Nov 17 2010 Paul Howarth <paul@city-fan.org> - 0.17-1
- Initial RPM build
